//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3EEC60110.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3EEC60110.cm

//## begin module%39A3EEC60110.cp preserve=no
//## end module%39A3EEC60110.cp

//## Module: SfResponse%39A3EEC60110; Package specification
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/Detector/SfResponse.h

#ifndef SFRESPONSE_H
#define SFRESPONSE_H 1

//## begin module%39A3EEC60110.additionalIncludes preserve=no
//## end module%39A3EEC60110.additionalIncludes

//## begin module%39A3EEC60110.includes preserve=yes
//## end module%39A3EEC60110.includes

// RealResponse
#include <XSModel/Data/Detector/RealResponse.h>
// SfIO
#include <XSModel/DataFactory/SfIO.h>
//## begin module%39A3EEC60110.declarations preserve=no
//## end module%39A3EEC60110.declarations

//## begin module%39A3EEC60110.additionalDeclarations preserve=yes
//## end module%39A3EEC60110.additionalDeclarations


//## begin SfResponse%3641DA44022B.preface preserve=yes
//## end SfResponse%3641DA44022B.preface

//## Class: SfResponse%3641DA44022B
//## Category: XSModel::Data::Detector%36349D570394
//## Subsystem: XSModel::Data::Detector%367691B76668
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A40E0FF01DC;SpectralData { -> }

class SfResponse : public RealResponse, //## Inherits: <unnamed>%376A61B603F0
                   	public SfIO  //## Inherits: <unnamed>%39A3ED4E00A2
{
  //## begin SfResponse%3641DA44022B.initialDeclarations preserve=yes
  //## end SfResponse%3641DA44022B.initialDeclarations

  public:
    //## Constructors (generated)
      SfResponse();

      SfResponse(const SfResponse &right);

    //## Destructor (generated)
      virtual ~SfResponse();


    //## Other Operations (specified)
      //## Operation: read%373B0D199828;       C++
      virtual size_t read (const string& fileName, bool readFlag = true);

      //## Operation: clone%380DF503FAF0
      virtual SfResponse* clone () const;

      //## Operation: fileFormat%39A3EDB20345
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: closeSourceFiles%3A3941080029
      void closeSourceFiles ();

    // Additional Public Declarations
      //## begin SfResponse%3641DA44022B.public preserve=yes
      //## end SfResponse%3641DA44022B.public

  protected:

    //## Other Operations (specified)
      //## Operation: setArrays%3A01E4490070
      virtual void setArrays ();

      //## Operation: setDescription%3A01E44F0145
      virtual void setDescription (size_t spectrumNumber = 1, size_t groupNumber = 1);

      //## Operation: Swap%3A95888403DF
      //## Exceptions: ()
      virtual void Swap (RealResponse& right) throw ();

    // Additional Protected Declarations
      //## begin SfResponse%3641DA44022B.protected preserve=yes
      //## end SfResponse%3641DA44022B.protected

  private:
    //## Assignment Operation (generated)
      SfResponse & operator=(const SfResponse &right);


    //## Other Operations (specified)
      //## Operation: copy%3A9568C40189
      virtual void copy (const RealResponse& right);

    // Additional Private Declarations
      //## begin SfResponse%3641DA44022B.private preserve=yes
      //## end SfResponse%3641DA44022B.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin SfResponse%3641DA44022B.implementation preserve=yes
      //## end SfResponse%3641DA44022B.implementation

};

//## begin SfResponse%3641DA44022B.postscript preserve=yes
//## end SfResponse%3641DA44022B.postscript

// Class SfResponse 

//## begin module%39A3EEC60110.epilog preserve=yes
//## end module%39A3EEC60110.epilog


#endif
